// Datei: Serial.c
//
// Serielle Datenbertragung
//
// In Empfangsrichtung wird ein Interrupt mit Ringpuffer benutzt !
// Die Routinen stammen von SDCC und sind eigentlich fr einen
// 8051 Controller gedacht. Geht ohne groe nderungen auch
// mit einem PIC.
//
// Holger Klabunde 
// 15.11.2002
// Compiler PICC18

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"

//#######################################
//Serielle Schnittstelle einstellen 
//xxxxxBaud ,8 Bit ,kein Parity, 1 Stopbit
//#######################################
void InitUSART(void)
{
 TXSTAbits.BRGH=1;

 rcnt=0;
 rpos=0;
 
// SPBRG=129; // (9600 baud @ 20MHz input clock)
 SPBRG=64; // (19200 baud @ 20MHz input clock)
// SPBRG=32; // (38400 baud @ 20MHz input clock)

 RCSTAbits.SPEN = 1; //  Set_Serial_Pins;

 TXSTAbits.SYNC = 0; //  Set_Async_Mode;

 TXSTAbits.TX9 = 0; //  Set_8bit_Tx;
 RCSTAbits.RX9 = 0; //  Set_8bit_Rx;
 RCSTAbits.CREN = 1; //  Enable_Rx;
 TXSTAbits.TXEN = 1; //  Enable_Tx;

 PIE1bits.RCIE=1;   // Rx Interrupt an
}

//#############################
//Ein Datenbyte empfangen
//bzw. aus dem Ringpuffer holen
//#############################
unsigned char Receive(void)
{
 unsigned char c;

 while(!rcnt);   /* wait for character */

 PIE1bits.RCIE=0;   //Disable Rx Interrupt

 rcnt--;   //ein Byte aus dem Puffer geholt
 c = rbuf [rpos++];
 if (rpos >= RBUFLEN) rpos = 0; //Ringzhler neu setzen

 PIE1bits.RCIE=1;   //Enable Rx Interrupt

 return (c);
}

//######################
//Ein Datenbyte senden
//######################
void Transmit(unsigned char dat)
{
 while(!PIR1bits.TXIF);   // Loop till TXREG empty, WDT off !

 TXREG = dat; // Send data
}
