// Datei: int.c
//
// Interruptroutine
//
// Holger Klabunde 
// 15.11.2002
// Compiler PICC18

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"

unsigned char rbuf[RBUFLEN]; //Ringpuffer fr Empfang

unsigned char pos,rec;   //RS232 Empfang
unsigned char rpos,rcnt; //RS232 Empfang

unsigned char icnt,idat1,idat2;      //I2C-Empfang

#pragma interrupt int_server

#pragma code lowVektor=0x08 //Fast Int.Vector
//#pragma code lowVektor=0x18 //Slow Int.Vector
void atlowVektor(void)
{
_asm GOTO int_server _endasm
}
#pragma code

void int_server( void)
{
//###############################
//Beginn I2C-Interrupt
//###############################

 if(PIR1bits.SSPIF)
  {
   if(SSPSTATbits.D_A==0) icnt=0;  //Meine I2C-Adresse empfangen, dann Bytezhler auf 0

   rec=SSPBUF;      //Auf jeden Fall SSPBUF lesen
                    //BF wird dann automatisch zurckgesetzt

   if(icnt==1) idat1=rec; //1. Datenbyte abholen
   if(icnt==2) idat2=rec; //2. Datenbyte abholen
   icnt++;
   
   SSPCON1bits.SSPOV=0;      //Sicherheitshalber Overflow Flag lschen
   PIR1bits.SSPIF=0;      //Int Flag lschen, sonst Endlosinterrupt
  }

//###############################
//Ende I2C-Interrupt
//###############################


//###############################
//Beginn RS232-Empfangs-Interrupt
//###############################
 if(PIR1bits.RCIF)
  {
//Routine von SDCC
	   /* don't overwrite chars already in buffer */
//	   if (rcnt < RBUFLEN)
//		   rbuf [(rpos+rcnt++) % RBUFLEN] = SBUF;

     rec=RCREG; //Daten auf jeden Fall abholen um RCIF zu lschen

     if(rcnt < RBUFLEN)
      {
       pos=rpos+rcnt;     //Ring Position im Array berechnen
       pos=pos % RBUFLEN; //Position auf jeden Fall im Array
       rcnt++;            //empfangene Bytes zhlen
       rbuf[pos] = rec; //Daten ins Array
      }
   //RCIF wird beim lesen von RCREG zurckgesetzt !
  }
//###############################
//Ende RS232-Empfangs-Interrupt
//###############################

//###############################
//Beginn Timer1-Interrupt
//###############################
 if(PIR1bits.TMR1IF)
  {
   keys=(~PORTA)&0x3F; //Porta lesen, lowaktiv, sechs Tasten
   
   PIR1bits.TMR1IF=0; //Int-Flag lschen. Wichtig ! Sonst Endlosinterrupt
  }
//###############################
//Ende Timer1-Interrupt
//###############################
}
